require 'spec_helper'

describe Assent::Config do

  let(:config) { Class.new {
      include Assent::Config

      def initialize
        super
      end

      def add(option, value)
        Assent::Config.add(option, value)
      end

      def config_file(path)
        puts path
        Assent::Config.config_file(path)
      end

      def config
        Assent::Config.config
      end
    }
  }


  describe '.config_file' do
    it 'loads the default config when no config file is set' do
      config_class = config.new
      expect(config_class.config["presence"]).to eq("The :field is required.")
    end

    it 'adds custom config to the config hash' do
      config_class = config.new
      config_class.config_file(File.dirname(__FILE__) + '/helpers/config.yml')
      expect(config_class.config["presence"]).to eq("This is custom config for :field")
    end

    after(:all) do
      config_class = Class.new{
        include Assent::Config

        def initialize
          super
        end
      }

      config_class.new.send(:set_empty_config)
    end
  end
end
